%{!?python_abi:      %define python_abi      %(%{__python} -c "import sys; print sys.version[:3]")}
%{!?python_sitelib:  %define python_sitelib  %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}


Summary:        A x86 shellcode emulation library
Name:           libemu
Version:        0.2.0
Release:        1%{?dist}%{?pext}
License:        GPL
Group:          System Environment/Libraries
Source0:        http://downloads.sourceforge.net/project/nepenthes/%{name}%20development/%{version}/%{name}-%{version}.tar.bz2
Patch0:         %{name}-0.2.0-build.patch
Patch1:         %{name}-0.2.0-install.patch
URL:            http://%{name}.carnivore.it/
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:         Paul Baecher, Markus Koetter <nepenthesdev@gmail.com>
BuildRequires:  python-devel >= 2.4 python-setuptools

%description
Libemu is a small library written in C offering basic x86 emulation and
shell code detection using GetPC heuristics. It is designed to be used
within network intrusion/prevention detections and honeypots.


%package        devel
Summary:        Development tools for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig

%description    devel
The %{name}-devel package contains the libraries and header files for
developing software using %{name}.


%package        prog
Summary:        Utilities for %{name}
Group:          Applications/Internet
Requires:       %{name} = %{version}-%{release}
Obsoletes:      %{name}-progs < %{version}-%{release}

%description    prog
The %{name}-progs package contains several console utilities for %{name}.


%package        static
Summary:        Static libraries for %{name}
Group:          Development/Libraries
Requires:       %{name}-devel = %{version}-%{release}

%description    static
The %{name}-static package contains the statically linkable libraries for
%{name}.


%package     -n python-emu
Summary:        Python bindings for %{name}
Group:          Development/Languages
Provides:       python(%{name}) = %{version}
Requires:       %{name} = %{version}-%{release}
Obsoletes:      python-%{name} < %{version}-%{release}

%description -n python-emu
The python-emu package contains the Python bindings for %{name}.


%prep
%setup -q
%patch0 -p1
%patch1 -p1


%build
%configure \
	--enable-static \
	--enable-shared \
	--enable-lfs

%{__make} %{?_smp_mflags}

# Build Python bindings
pushd bindings/python
%{__python} -c 'import setuptools; execfile("setup.py")' build
popd


%check
pushd testsuite
./testsuite
popd


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__rm} -f ${RPM_BUILD_ROOT}%{_libdir}/%{name}.so.?

# Install Python bindings
pushd bindings/python
%{__python} -c 'import setuptools; execfile("setup.py")' install \
	--skip-build -O1 --root ${RPM_BUILD_ROOT}
popd


%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc AUTHORS CHANGES README
%{_libdir}/%{name}.so.*

%files devel
%defattr(-,root,root)
%{_includedir}/emu
%{_libdir}/%{name}.la
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_mandir}/man3/*.3*

%files prog
%defattr(-,root,root)
%{_bindir}/scprofiler
%{_bindir}/sctest

%files static
%defattr(-,root,root)
%{_libdir}/%{name}.a

%files -n python-emu
%defattr(-,root,root)
%{python_sitearch}/%{name}.so
%{python_sitearch}/*.egg-info


%changelog
* Mon Mar 03 2014 Peter Pramberger <peterpramb@member.fsf.org> - 0.2.0-1
- New version (0.2.0)

* Fri Aug 05 2011 Peter Pramberger <peterpramb@member.fsf.org> - 0.2.0-0.1.20110805git
- Initial build
